plugins {
    alias(libs.plugins.android.library)
    alias(libs.plugins.kotlin.android)
    alias(libs.plugins.kotlin.kapt)
}

android {
    namespace = "com.tenlionsoft.baselib"
    compileSdk = 34

    defaultConfig {
        minSdk = 24

        testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner"
        consumerProguardFiles("consumer-rules.pro")
    }
    buildFeatures {
        viewBinding = true
        dataBinding = true
    }
    buildTypes {
        release {
            isMinifyEnabled = false
            proguardFiles(
                getDefaultProguardFile("proguard-android-optimize.txt"),
                "proguard-rules.pro"
            )
        }
    }
    compileOptions {
        sourceCompatibility = JavaVersion.VERSION_1_8
        targetCompatibility = JavaVersion.VERSION_1_8
    }
    kotlinOptions {
        jvmTarget = "1.8"
    }
}

dependencies {

    implementation(libs.androidx.core.ktx)
    api(libs.androidx.appcompat)
    implementation(libs.material)
    testImplementation(libs.junit)
    androidTestImplementation(libs.androidx.junit)
    androidTestImplementation(libs.androidx.espresso.core)

    api(libs.rxjava)
    api(libs.rxandroid)
    implementation(libs.mmkv)
    implementation(libs.room)
    kapt(libs.roomCompiler)
    api(libs.lifecycleViewModel)
    api(libs.rxkotlin)
    api(libs.glide)

    api(libs.retrofit)
    api(libs.okHttp3)
    api(libs.gson)
    api(libs.rxAdapter)
    api(libs.rxCoverterAdapter)
    api(libs.smartRefreshLayout)
    api(libs.refreshHeader)
    api(libs.refreshFoot)
    api(libs.jjwt)
    api(libs.emojipicker)
    api(libs.xxpermissions)
    api(libs.filepicker)
}