package com.tenlionsoft.baselib.base

import android.content.Context
import android.view.View
import android.view.WindowManager
import android.view.inputmethod.InputMethodManager
import androidx.core.content.ContextCompat
import com.tenlionsoft.baselib.R
import kotlin.system.exitProcess


abstract class BaseActivity : DataBindingActivity() {
    fun exitApp() {
        android.os.Process.killProcess(android.os.Process.myPid());    //获取PID
        exitProcess(0);   //常规java、c#的标准退出法，返回值为0代表正常退出
    }

    fun hideSoftKeyboard() {
        hideSoftKeyboard(currentFocus)
    }

    private fun hideSoftKeyboard(et: View?) {
        val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
        if (et != null) {
            imm.hideSoftInputFromWindow(et.windowToken, 0)
        }
    }

    fun showSoftKeyBoard(view: View?) {
        val imm = getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        if (view != null) {
            imm.showSoftInput(view, 0)
        }
    }

    fun setStatusBarColor(dark: Boolean) {
        val window = window
        if (dark) {
            window.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS)
            window.statusBarColor = ContextCompat.getColor(this, com.tenlionsoft.baselib.R.color.tr)
        } else {
            window.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS)
            window.statusBarColor = ContextCompat.getColor(this, R.color.white)
        }

    }
}