package com.tenlionsoft.baselib.net

import android.os.Handler
import okhttp3.Call
import okhttp3.Callback
import okhttp3.Response
import java.io.File
import java.io.FileOutputStream
import java.io.IOException
import java.io.InputStream

class DownloadCallback : Callback {
    private var mHandler: Handler? = null
    private var mDownloadResponseHandler: DownloadResponseHandler? = null
    private var mFileDir: String? = null
    private var mFilename: String? = null


    constructor(
        handler: Handler, downloadResponseHandler: DownloadResponseHandler,
        filedir: String, filename: String
    ) {
        mHandler = handler
        mDownloadResponseHandler = downloadResponseHandler
        mFileDir = filedir
        mFilename = filename
    }


    override fun onFailure(call: Call, e: IOException) {
        mHandler!!.post { mDownloadResponseHandler!!.onFailure(e.toString()) }
    }

    override fun onResponse(call: Call, response: Response) {
        if (response.isSuccessful) {
            var file: File? = null
            try {
                file = saveFile(response, mFileDir!!, mFilename!!)
            } catch (e: IOException) {
                mHandler!!.post { mDownloadResponseHandler!!.onFailure("onResponse saveFile fail.$e") }
            }
            val newFile = file
            mHandler!!.post { mDownloadResponseHandler!!.onFinish(newFile) }
        } else {
            mHandler!!.post { mDownloadResponseHandler!!.onFailure("fail status=" + response.code) }
        }
    }

    //保存文件
    @Throws(IOException::class)
    private fun saveFile(response: Response, filedir: String, filename: String): File {
        var `is`: InputStream? = null
        val buf = ByteArray(2048)
        var len: Int
        var fos: FileOutputStream? = null
        try {
            `is` = response.body!!.byteStream()
            val dir = File(filedir)
            if (!dir.exists()) {
                dir.mkdirs()
            }
            val file = File(dir, filename)
            fos = FileOutputStream(file)
            while ((`is`.read(buf).also { len = it }) != -1) {
                fos.write(buf, 0, len)
            }
            fos.flush()
            return file
        } finally {
            try {
                `is`?.close()
            } catch (e: IOException) {
            }
            try {
                fos?.close()
            } catch (e: IOException) {
            }
        }
    }

}